package foo;

import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.transaction.TransactionConfiguration;
import org.springframework.transaction.annotation.Transactional;
import org.junit.runner.RunWith;
import org.junit.Test;
import org.jbpm.api.TaskService;
import org.jbpm.api.IdentityService;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.Execution;
import org.jbpm.api.task.Task;
import org.jbpm.test.AbstractTransactionalSpringJbpmTestCase;

import javax.annotation.Resource;
import java.util.List;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {
        "/spring-config.xml"
})
@Transactional
@TransactionConfiguration(transactionManager = "transactionManager")
public class TaskTests extends AbstractTransactionalSpringJbpmTestCase {


    @Resource
    WorkflowService workflowService;

    @Resource
    TaskService taskService;

    @Resource
    IdentityService identityService;


    @Test
    public void testTask() {

        assertEquals(0, taskService.findPersonalTasks("tester").size());

        ProcessInstance pi = workflowService.startApprovingProcess("foo");

        List<Task> taskList = taskService.findPersonalTasks("tester");
        assertNotNull(taskList);
        assertEquals(taskList.size(), 1);

        Task task = taskList.get(0);
        taskService.completeTask(task.getId(), "yes");

        taskList = taskService.findPersonalTasks("tester");
        assertNotNull(taskList);
        assertEquals(taskList.size(), 0);


    }

}
